// -*- C++ -*-
//
// This file was generated by CLI, a command line interface
// compiler for C++.
//

// Begin prologue.
//
#include <bpkg/types-parsers.hxx>
//
// End prologue.

#include <bpkg/pkg-status-options.hxx>

#include <map>
#include <set>
#include <string>
#include <vector>
#include <ostream>
#include <sstream>

namespace bpkg
{
  namespace cli
  {
    template <typename X>
    struct parser
    {
      static void
      parse (X& x, bool& xs, scanner& s)
      {
        using namespace std;

        const char* o (s.next ());
        if (s.more ())
        {
          string v (s.next ());
          istringstream is (v);
          if (!(is >> x && is.peek () == istringstream::traits_type::eof ()))
            throw invalid_value (o, v);
        }
        else
          throw missing_value (o);

        xs = true;
      }

      static void
      merge (X& b, const X& a)
      {
        b = a;
      }
    };

    template <>
    struct parser<bool>
    {
      static void
      parse (bool& x, scanner& s)
      {
        s.next ();
        x = true;
      }

      static void
      merge (bool& b, const bool&)
      {
        b = true;
      }
    };

    template <>
    struct parser<std::string>
    {
      static void
      parse (std::string& x, bool& xs, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
          x = s.next ();
        else
          throw missing_value (o);

        xs = true;
      }

      static void
      merge (std::string& b, const std::string& a)
      {
        b = a;
      }
    };

    template <typename X>
    struct parser<std::vector<X> >
    {
      static void
      parse (std::vector<X>& c, bool& xs, scanner& s)
      {
        X x;
        bool dummy;
        parser<X>::parse (x, dummy, s);
        c.push_back (x);
        xs = true;
      }

      static void
      merge (std::vector<X>& b, const std::vector<X>& a)
      {
        b.insert (b.end (), a.begin (), a.end ());
      }
    };

    template <typename X>
    struct parser<std::set<X> >
    {
      static void
      parse (std::set<X>& c, bool& xs, scanner& s)
      {
        X x;
        bool dummy;
        parser<X>::parse (x, dummy, s);
        c.insert (x);
        xs = true;
      }

      static void
      merge (std::set<X>& b, const std::set<X>& a)
      {
        b.insert (a.begin (), a.end ());
      }
    };

    template <typename K, typename V>
    struct parser<std::map<K, V> >
    {
      static void
      parse (std::map<K, V>& m, bool& xs, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
        {
          std::string ov (s.next ());
          std::string::size_type p = ov.find ('=');

          K k = K ();
          V v = V ();
          std::string kstr (ov, 0, p);
          std::string vstr (ov, (p != std::string::npos ? p + 1 : ov.size ()));

          int ac (2);
          char* av[] =
          {
            const_cast<char*> (o),
            0
          };

          bool dummy;
          if (!kstr.empty ())
          {
            av[1] = const_cast<char*> (kstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<K>::parse (k, dummy, s);
          }

          if (!vstr.empty ())
          {
            av[1] = const_cast<char*> (vstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<V>::parse (v, dummy, s);
          }

          m[k] = v;
        }
        else
          throw missing_value (o);

        xs = true;
      }

      static void
      merge (std::map<K, V>& b, const std::map<K, V>& a)
      {
        for (typename std::map<K, V>::const_iterator i (a.begin ()); 
             i != a.end (); 
             ++i)
          b[i->first] = i->second;
      }
    };

    template <typename X, typename T, T X::*M>
    void
    thunk (X& x, scanner& s)
    {
      parser<T>::parse (x.*M, s);
    }

    template <typename X, typename T, T X::*M, bool X::*S>
    void
    thunk (X& x, scanner& s)
    {
      parser<T>::parse (x.*M, x.*S, s);
    }
  }
}

#include <map>
#include <cstring>

namespace bpkg
{
  // pkg_status_options
  //

  pkg_status_options::
  pkg_status_options ()
  : immediate_ (),
    recursive_ (),
    old_available_ (),
    constraint_ (),
    system_ (),
    no_hold_ (),
    no_hold_package_ (),
    no_hold_version_ ()
  {
  }

  bool pkg_status_options::
  parse (int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    bool r = _parse (s, opt, arg);
    return r;
  }

  bool pkg_status_options::
  parse (int start,
         int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    bool r = _parse (s, opt, arg);
    return r;
  }

  bool pkg_status_options::
  parse (int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    bool r = _parse (s, opt, arg);
    end = s.end ();
    return r;
  }

  bool pkg_status_options::
  parse (int start,
         int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    bool r = _parse (s, opt, arg);
    end = s.end ();
    return r;
  }

  bool pkg_status_options::
  parse (::bpkg::cli::scanner& s,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    bool r = _parse (s, opt, arg);
    return r;
  }

  void pkg_status_options::
  merge (const pkg_status_options& a)
  {
    CLI_POTENTIALLY_UNUSED (a);

    // configuration_options base
    //
    ::bpkg::configuration_options::merge (a);

    if (a.immediate_)
    {
      ::bpkg::cli::parser< bool>::merge (
        this->immediate_, a.immediate_);
    }

    if (a.recursive_)
    {
      ::bpkg::cli::parser< bool>::merge (
        this->recursive_, a.recursive_);
    }

    if (a.old_available_)
    {
      ::bpkg::cli::parser< bool>::merge (
        this->old_available_, a.old_available_);
    }

    if (a.constraint_)
    {
      ::bpkg::cli::parser< bool>::merge (
        this->constraint_, a.constraint_);
    }

    if (a.system_)
    {
      ::bpkg::cli::parser< bool>::merge (
        this->system_, a.system_);
    }

    if (a.no_hold_)
    {
      ::bpkg::cli::parser< bool>::merge (
        this->no_hold_, a.no_hold_);
    }

    if (a.no_hold_package_)
    {
      ::bpkg::cli::parser< bool>::merge (
        this->no_hold_package_, a.no_hold_package_);
    }

    if (a.no_hold_version_)
    {
      ::bpkg::cli::parser< bool>::merge (
        this->no_hold_version_, a.no_hold_version_);
    }
  }

  ::bpkg::cli::usage_para pkg_status_options::
  print_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mPKG-STATUS OPTIONS\033[0m" << ::std::endl;

    os << std::endl
       << "\033[1m--immediate\033[0m|\033[1m-i\033[0m           Also print the status of immediate dependencies." << ::std::endl;

    os << std::endl
       << "\033[1m--recursive\033[0m|\033[1m-r\033[0m           Also print the status of all dependencies," << ::std::endl
       << "                         recursively." << ::std::endl;

    os << std::endl
       << "\033[1m--old-available\033[0m|\033[1m-o\033[0m       Print old available versions." << ::std::endl;

    os << std::endl
       << "\033[1m--constraint\033[0m             Print version constraints for dependencies." << ::std::endl;

    os << std::endl
       << "\033[1m--system\033[0m                 Check the availability of packages from the system." << ::std::endl;

    os << std::endl
       << "\033[1m--no-hold\033[0m                Don't print the package or version hold status." << ::std::endl;

    os << std::endl
       << "\033[1m--no-hold-package\033[0m        Don't print the package hold status." << ::std::endl;

    os << std::endl
       << "\033[1m--no-hold-version\033[0m        Don't print the version hold status." << ::std::endl;

    p = ::bpkg::cli::usage_para::option;

    // configuration_options base
    //
    p = ::bpkg::configuration_options::print_usage (os, p);

    return p;
  }

  typedef
  std::map<std::string, void (*) (pkg_status_options&, ::bpkg::cli::scanner&)>
  _cli_pkg_status_options_map;

  static _cli_pkg_status_options_map _cli_pkg_status_options_map_;

  struct _cli_pkg_status_options_map_init
  {
    _cli_pkg_status_options_map_init ()
    {
      _cli_pkg_status_options_map_["--immediate"] =
      &::bpkg::cli::thunk< pkg_status_options, bool, &pkg_status_options::immediate_ >;
      _cli_pkg_status_options_map_["-i"] =
      &::bpkg::cli::thunk< pkg_status_options, bool, &pkg_status_options::immediate_ >;
      _cli_pkg_status_options_map_["--recursive"] =
      &::bpkg::cli::thunk< pkg_status_options, bool, &pkg_status_options::recursive_ >;
      _cli_pkg_status_options_map_["-r"] =
      &::bpkg::cli::thunk< pkg_status_options, bool, &pkg_status_options::recursive_ >;
      _cli_pkg_status_options_map_["--old-available"] =
      &::bpkg::cli::thunk< pkg_status_options, bool, &pkg_status_options::old_available_ >;
      _cli_pkg_status_options_map_["-o"] =
      &::bpkg::cli::thunk< pkg_status_options, bool, &pkg_status_options::old_available_ >;
      _cli_pkg_status_options_map_["--constraint"] =
      &::bpkg::cli::thunk< pkg_status_options, bool, &pkg_status_options::constraint_ >;
      _cli_pkg_status_options_map_["--system"] =
      &::bpkg::cli::thunk< pkg_status_options, bool, &pkg_status_options::system_ >;
      _cli_pkg_status_options_map_["--no-hold"] =
      &::bpkg::cli::thunk< pkg_status_options, bool, &pkg_status_options::no_hold_ >;
      _cli_pkg_status_options_map_["--no-hold-package"] =
      &::bpkg::cli::thunk< pkg_status_options, bool, &pkg_status_options::no_hold_package_ >;
      _cli_pkg_status_options_map_["--no-hold-version"] =
      &::bpkg::cli::thunk< pkg_status_options, bool, &pkg_status_options::no_hold_version_ >;
    }
  };

  static _cli_pkg_status_options_map_init _cli_pkg_status_options_map_init_;

  bool pkg_status_options::
  _parse (const char* o, ::bpkg::cli::scanner& s)
  {
    _cli_pkg_status_options_map::const_iterator i (_cli_pkg_status_options_map_.find (o));

    if (i != _cli_pkg_status_options_map_.end ())
    {
      (*(i->second)) (*this, s);
      return true;
    }

    // configuration_options base
    //
    if (::bpkg::configuration_options::_parse (o, s))
      return true;

    return false;
  }

  bool pkg_status_options::
  _parse (::bpkg::cli::scanner& s,
          ::bpkg::cli::unknown_mode opt_mode,
          ::bpkg::cli::unknown_mode arg_mode)
  {
    // Can't skip combined flags (--no-combined-flags).
    //
    assert (opt_mode != ::bpkg::cli::unknown_mode::skip);

    bool r = false;
    bool opt = true;

    while (s.more ())
    {
      const char* o = s.peek ();

      if (std::strcmp (o, "--") == 0)
      {
        opt = false;
      }

      if (opt)
      {
        if (_parse (o, s))
        {
          r = true;
          continue;
        }

        if (std::strncmp (o, "-", 1) == 0 && o[1] != '\0')
        {
          // Handle combined option values.
          //
          std::string co;
          if (const char* v = std::strchr (o, '='))
          {
            co.assign (o, 0, v - o);
            ++v;

            int ac (2);
            char* av[] =
            {
              const_cast<char*> (co.c_str ()),
              const_cast<char*> (v)
            };

            ::bpkg::cli::argv_scanner ns (0, ac, av);

            if (_parse (co.c_str (), ns))
            {
              // Parsed the option but not its value?
              //
              if (ns.end () != 2)
                throw ::bpkg::cli::invalid_value (co, v);

              s.next ();
              r = true;
              continue;
            }
            else
            {
              // Set the unknown option and fall through.
              //
              o = co.c_str ();
            }
          }

          // Handle combined flags.
          //
          char cf[3];
          {
            const char* p = o + 1;
            for (; *p != '\0'; ++p)
            {
              if (!((*p >= 'a' && *p <= 'z') ||
                    (*p >= 'A' && *p <= 'Z') ||
                    (*p >= '0' && *p <= '9')))
                break;
            }

            if (*p == '\0')
            {
              for (p = o + 1; *p != '\0'; ++p)
              {
                std::strcpy (cf, "-");
                cf[1] = *p;
                cf[2] = '\0';

                int ac (1);
                char* av[] =
                {
                  cf
                };

                ::bpkg::cli::argv_scanner ns (0, ac, av);

                if (!_parse (cf, ns))
                  break;
              }

              if (*p == '\0')
              {
                // All handled.
                //
                s.next ();
                r = true;
                continue;
              }
              else
              {
                // Set the unknown option and fall through.
                //
                o = cf;
              }
            }
          }

          switch (opt_mode)
          {
            case ::bpkg::cli::unknown_mode::skip:
            {
              s.skip ();
              r = true;
              continue;
            }
            case ::bpkg::cli::unknown_mode::stop:
            {
              break;
            }
            case ::bpkg::cli::unknown_mode::fail:
            {
              throw ::bpkg::cli::unknown_option (o);
            }
          }

          break;
        }
      }

      switch (arg_mode)
      {
        case ::bpkg::cli::unknown_mode::skip:
        {
          s.skip ();
          r = true;
          continue;
        }
        case ::bpkg::cli::unknown_mode::stop:
        {
          break;
        }
        case ::bpkg::cli::unknown_mode::fail:
        {
          throw ::bpkg::cli::unknown_argument (o);
        }
      }

      break;
    }

    return r;
  }
}

namespace bpkg
{
  ::bpkg::cli::usage_para
  print_bpkg_pkg_status_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mSYNOPSIS\033[0m" << ::std::endl
       << ::std::endl
       << "\033[1mbpkg pkg-status\033[0m|\033[1mstatus\033[0m [\033[4moptions\033[0m] [\033[4mpkg\033[0m[\033[1m/\033[0m\033[4mver\033[0m]...]\033[0m" << ::std::endl
       << ::std::endl
       << "\033[1mDESCRIPTION\033[0m" << ::std::endl
       << ::std::endl
       << "The \033[1mpkg-status\033[0m command prints the status of the specified packages or, if \033[4mver\033[0m" << ::std::endl
       << "is specified, package versions. If no packages were specified, then \033[1mpkg-status\033[0m" << ::std::endl
       << "prints the status of all the held packages (which are the packages that were" << ::std::endl
       << "explicitly built; see \033[1mbpkg-pkg-build(1)\033[0m). Additionally, the status of immediate" << ::std::endl
       << "or all dependencies of the above packages can be printed by specifying the" << ::std::endl
       << "\033[1m--immediate\033[0m|\033[1m-i\033[0m\033[0m or \033[1m--recursive\033[0m|\033[1m-r\033[0m\033[0m options, respectively. Note that the status is" << ::std::endl
       << "written to \033[1mstdout\033[0m, not \033[1mstderr\033[0m." << ::std::endl
       << ::std::endl
       << "The status output format is regular with components separated with spaces. Each" << ::std::endl
       << "line starts with the package name (and version, if specified) followed by one" << ::std::endl
       << "of the status words listed below.  Some of them can be optionally followed by" << ::std::endl
       << "'\033[1m,\033[0m' (no spaces) and a sub-status word." << ::std::endl
       << ::std::endl
       << "\033[1munknown\033[0m" << ::std::endl
       << "    Package is not part of the configuration nor available from any of the" << ::std::endl
       << "    repositories." << ::std::endl
       << "\033[1mavailable\033[0m" << ::std::endl
       << "    Package is not part of the configuration but is available from one of the" << ::std::endl
       << "    repositories." << ::std::endl
       << "\033[1mfetched\033[0m" << ::std::endl
       << "    Package is part of the configuration and is fetched." << ::std::endl
       << "\033[1munpacked\033[0m" << ::std::endl
       << "    Package is part of the configuration and is unpacked." << ::std::endl
       << "\033[1mconfigured\033[0m" << ::std::endl
       << "    Package is part of the configuration and is configured. May be followed by" << ::std::endl
       << "    the \033[1msystem\033[0m sub-status indicating a package coming from the system. The" << ::std::endl
       << "    version of such a system package (described below) may be the special '\033[1m*\033[0m'" << ::std::endl
       << "    value indicating a wildcard version." << ::std::endl
       << "\033[1mbroken\033[0m" << ::std::endl
       << "    Package is part of the configuration and is broken (broken packages can" << ::std::endl
       << "    only be purged; see \033[1mbpkg-pkg-purge(1)\033[0m)." << ::std::endl
       << ::std::endl
       << "If only the package name was specified without the package version, then the" << ::std::endl
       << "\033[1mavailable\033[0m status word is followed by the list of available versions. Versions" << ::std::endl
       << "that are only available for up/down-grading are printed in '\033[1m[]\033[0m' (such version" << ::std::endl
       << "are only available as dependencies from prerequisite repositories of other" << ::std::endl
       << "repositories). If the \033[1m--system\033[0m option is specified, then the last version in" << ::std::endl
       << "this list may have the \033[1msys:\033[0m prefix indicating an available system version. Such" << ::std::endl
       << "a system version may be the special '\033[1m?\033[0m' value indicating that a package may or" << ::std::endl
       << "may not be available from the system and that its version is unknown." << ::std::endl
       << ::std::endl
       << "Similarly, if only the package name was specified, then the \033[1mfetched\033[0m, \033[1munpacked\033[0m," << ::std::endl
       << "\033[1mconfigured\033[0m, and \033[1mbroken\033[0m status words are followed by the version of the package." << ::std::endl
       << "If newer versions are available, then the package version is followed by the" << ::std::endl
       << "\033[1mavailable\033[0m status word and the list of newer versions. To instead see a list of" << ::std::endl
       << "all versions, including the older ones, specify the \033[1m--old-available\033[0m|\033[1m-o\033[0m\033[0m option." << ::std::endl
       << "In this case the currently selected version is printed in '\033[1m()\033[0m'." << ::std::endl
       << ::std::endl
       << "If the package name was specified with the version, then only the status (such" << ::std::endl
       << "as, \033[1mconfigured\033[0m, \033[1mavailable\033[0m, etc.) of this version is considered." << ::std::endl
       << ::std::endl
       << "If a package is being held, then its name is printed prefixed with '\033[1m!\033[0m'." << ::std::endl
       << "Similarly, if a package version is being held, then the version is printed" << ::std::endl
       << "prefixed with '\033[1m!\033[0m'. Held packages and held versions were selected by the user" << ::std::endl
       << "and are not automatically dropped and upgraded, respectively." << ::std::endl
       << ::std::endl
       << "Below are some examples, assuming the configuration has \033[1mlibfoo\033[0m \033[1m1.0.0\033[0m configured" << ::std::endl
       << "and held (both package and version) as well as \033[1mlibfoo\033[0m \033[1m1.1.0\033[0m and \033[1m1.1.1\033[0m available" << ::std::endl
       << "from source and \033[1m1.1.0\033[0m from the system." << ::std::endl
       << ::std::endl
       << "bpkg status libbar" << ::std::endl
       << "libbar unknown" << ::std::endl
       << ::std::endl
       << "bpkg status libbar/1.0.0" << ::std::endl
       << "libbar/1.0.0 unknown" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo/1.0.0" << ::std::endl
       << "!libfoo/1.0.0 configured !1.0.0" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo/1.1.0" << ::std::endl
       << "libfoo/1.1.0 available 1.1.0" << ::std::endl
       << ::std::endl
       << "bpkg status --system libfoo/1.1.0" << ::std::endl
       << "libfoo/1.1.0 available 1.1.0 sys:1.1.0" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo" << ::std::endl
       << "!libfoo configured !1.0.0 available 1.1.0 1.1.1" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo/1.1.1 libbar" << ::std::endl
       << "libfoo/1.1.1 available 1.1.1" << ::std::endl
       << "libbar unknown" << ::std::endl
       << ::std::endl
       << "Assuming now that we dropped \033[1mlibfoo\033[0m from the configuration:" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo/1.0.0" << ::std::endl
       << "libfoo/1.0.0 unknown" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo" << ::std::endl
       << "libfoo available 1.1.0 1.1.1" << ::std::endl
       << ::std::endl
       << "And assuming now that we built \033[1mlibfoo\033[0m as a system package with the wildcard" << ::std::endl
       << "version:" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo" << ::std::endl
       << "!libfoo configured,system * available 1.1.0 1.1.1" << ::std::endl;

    p = ::bpkg::pkg_status_options::print_usage (os, ::bpkg::cli::usage_para::text);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mDEFAULT OPTIONS FILES\033[0m" << ::std::endl
       << ::std::endl
       << "See \033[1mbpkg-default-options-files(1)\033[0m for an overview of the default options files." << ::std::endl
       << "For the \033[1mpkg-status\033[0m command the search start directory is the configuration" << ::std::endl
       << "directory. The following options files are searched for in each directory and," << ::std::endl
       << "if found, loaded in the order listed:" << ::std::endl
       << ::std::endl
       << "bpkg.options" << ::std::endl
       << "bpkg-pkg-status.options" << ::std::endl
       << ::std::endl
       << "The following \033[1mpkg-status\033[0m command options cannot be specified in the default" << ::std::endl
       << "options files:" << ::std::endl
       << ::std::endl
       << "--directory|-d" << ::std::endl;

    p = ::bpkg::cli::usage_para::text;

    return p;
  }
}

// Begin epilogue.
//
//
// End epilogue.

